#include "HelloWorldScene.h"
#include "cocostudio/CocoStudio.h"
#include "ui/CocosGUI.h"

USING_NS_CC;

using namespace cocostudio::timeline;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !Layer::init() )
    {
        return false;
    }
    
    auto rootNode = CSLoader::createNode("MainScene.csb");

    addChild(rootNode);

	_wsiSendText = new WebSocket();
	if (!_wsiSendText->init(*this, "<Web socket address>")) //format is ws://<ipaddress or URL>:<port number>/<endpoint>
	{
		CCLOG("Websocket init failed");
	}
	
	
    return true;
}

void HelloWorld::onOpen(WebSocket* ws)
{
	CCLOG("Websocket connected");
	 _wsiSendText->send("Hello WebSocket, I'm a text message.");
}

void HelloWorld::onMessage(cocos2d::network::WebSocket* ws, const cocos2d::network::WebSocket::Data& data)
{
	std::string textStr = data.bytes;
	CCLOG("Response: %s", textStr.c_str());
}

void HelloWorld::onClose(WebSocket* ws)
{
	CCLOG("Websocket closed");
}

void HelloWorld::onError(WebSocket* ws, const network::WebSocket::ErrorCode& error)
{
	CCLOG("Error was fired, error code: %d", error);
}